# 2024-09-03 Triage Log

This week we had some trouble with our performance bot, but luckily the issue has been resolved.
In the end, we saw much more improvements than regressions.

Triage done by **@kobzol**.
Revision range: [acb4e8b6..6199b69c](https://perf.rust-lang.org/?start=acb4e8b6251f1d8da36f08e7a70fa23fc581839e&end=6199b69c53a8c275ca3cd59647ea0af5ca29aae2&absolute=false&stat=instructions%3Au)

**Summary**:

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.3%  | [0.2%, 0.4%]   | 8     |
| Regressions ❌ <br /> (secondary)  | 0.7%  | [0.2%, 1.5%]   | 9     |
| Improvements ✅ <br /> (primary)   | -0.8% | [-3.4%, -0.2%] | 158   |
| Improvements ✅ <br /> (secondary) | -0.7% | [-2.3%, -0.2%] | 96    |
| All ❌✅ (primary)                 | -0.7% | [-3.4%, 0.4%]  | 166   |


2 Regressions, 3 Improvements, 1 Mixed; 3 of them in rollups
19 artifact comparisons made in total

#### Regressions

Rollup of 7 pull requests [#129750](https://github.com/rust-lang/rust/pull/129750) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=784d444733d65c3d305ce5edcbb41e3d0d0aee2e&end=0d634185dfddefe09047881175f35c65d68dcff1&stat=instructions:u)

| (instructions:u)                   | mean | range        | count |
|:----------------------------------:|:----:|:------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.4% | [0.3%, 0.5%] | 7     |
| Regressions ❌ <br /> (secondary)  | 6.0% | [6.0%, 6.0%] | 1     |
| Improvements ✅ <br /> (primary)   | -    | -            | 0     |
| Improvements ✅ <br /> (secondary) | -    | -            | 0     |
| All ❌✅ (primary)                 | 0.4% | [0.3%, 0.5%] | 7     |

- This was bimodal noise.

Rollup of 8 pull requests [#129922](https://github.com/rust-lang/rust/pull/129922) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=6199b69c53a8c275ca3cd59647ea0af5ca29aae2&end=d6c8169c186ab16a3404cd0d0866674018e8a19e&stat=instructions:u)

| (instructions:u)                   | mean | range        | count |
|:----------------------------------:|:----:|:------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -    | -            | 0     |
| Regressions ❌ <br /> (secondary)  | 5.8% | [5.8%, 5.8%] | 1     |
| Improvements ✅ <br /> (primary)   | -    | -            | 0     |
| Improvements ✅ <br /> (secondary) | -    | -            | 0     |
| All ❌✅ (primary)                 | -    | -            | 0     |

- Likely the same story, just with a different benchmark.
- Not marking as triaged yet.

#### Improvements

Rollup of 15 pull requests [#129809](https://github.com/rust-lang/rust/pull/129809) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=fa72f0763de6bc1596208fc1419883ce5aea0de4&end=9649706eada1b2c68cf6504356efb058f68ad739&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -0.3% | [-0.9%, -0.2%] | 21    |
| Improvements ✅ <br /> (secondary) | -0.7% | [-5.9%, -0.1%] | 18    |
| All ❌✅ (primary)                 | -0.3% | [-0.9%, -0.2%] | 21    |


Revert "Auto merge of #127537 - veluca93:struct_tf, r=BoxyUwU" [#129854](https://github.com/rust-lang/rust/pull/129854) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=a48861a6279b386ad2b9c3518490181d238fe727&end=94885bc699512cfee8560e73c2a01ee6b4b76563&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -0.4% | [-1.1%, -0.2%] | 81    |
| Improvements ✅ <br /> (secondary) | -0.5% | [-2.2%, -0.2%] | 24    |
| All ❌✅ (primary)                 | -0.4% | [-1.1%, -0.2%] | 81    |

- Revert of an earlier PR that had larger than expected regressions.
- Investigation is ongoing on how to land it without such large regressions.

Apply size optimizations to panic machinery and some cold functions [#129063](https://github.com/rust-lang/rust/pull/129063) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=94885bc699512cfee8560e73c2a01ee6b4b76563&end=e71f9529121ca8f687e4b725e3c9adc3f1ebab4d&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.2%  | [0.2%, 0.2%]   | 2     |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -1.2% | [-3.0%, -0.3%] | 16    |
| Improvements ✅ <br /> (secondary) | -1.0% | [-1.5%, -0.4%] | 4     |
| All ❌✅ (primary)                 | -1.0% | [-3.0%, 0.2%]  | 18    |


#### Mixed

Rewrite lint_expectations in a single pass. [#127313](https://github.com/rust-lang/rust/pull/127313) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=1a1cc050d8efc906ede39f444936ade1fdc9c6cb&end=a48861a6279b386ad2b9c3518490181d238fe727&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.4%  | [0.3%, 0.4%]   | 9     |
| Regressions ❌ <br /> (secondary)  | 0.6%  | [0.2%, 1.5%]   | 14    |
| Improvements ✅ <br /> (primary)   | -0.5% | [-1.5%, -0.2%] | 82    |
| Improvements ✅ <br /> (secondary) | -0.7% | [-1.8%, -0.1%] | 58    |
| All ❌✅ (primary)                 | -0.4% | [-1.5%, 0.4%]  | 91    |

- More improvements than regressions, marking as triaged.
