# 2024-09-10 Triage Log

A relatively quiet week with a majority of regressions coming in rollups which makes investigation more difficult. Luckily the regressions are relatively small and overall the week was a slight improvement in compiler performance.

Triage done by **@rylev**.
Revision range: [6199b69c..263a3aee](https://perf.rust-lang.org/?start=6199b69c53a8c275ca3cd59647ea0af5ca29aae2&end=263a3aeeb8f2d0e9cc85eee61774d1f5f23dc3f5&absolute=false&stat=instructions%3Au)

**Summary**:

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.6%  | [0.2%, 1.4%]   | 57    |
| Regressions ❌ <br /> (secondary)  | 0.7%  | [0.2%, 1.5%]   | 23    |
| Improvements ✅ <br /> (primary)   | -2.2% | [-4.0%, -0.4%] | 23    |
| Improvements ✅ <br /> (secondary) | -0.3% | [-0.3%, -0.2%] | 10    |
| All ❌✅ (primary)                 | -0.2% | [-4.0%, 1.4%]  | 80    |


3 Regressions, 1 Improvement, 2 Mixed; 3 of them in rollups
26 artifact comparisons made in total

#### Regressions

Rollup of 8 pull requests [#129922](https://github.com/rust-lang/rust/pull/129922) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=6199b69c53a8c275ca3cd59647ea0af5ca29aae2&end=d6c8169c186ab16a3404cd0d0866674018e8a19e&stat=instructions:u)

| (instructions:u)                   | mean | range        | count |
|:----------------------------------:|:----:|:------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -    | -            | 0     |
| Regressions ❌ <br /> (secondary)  | 5.8% | [5.8%, 5.8%] | 1     |
| Improvements ✅ <br /> (primary)   | -    | -            | 0     |
| Improvements ✅ <br /> (secondary) | -    | -            | 0     |
| All ❌✅ (primary)                 | -    | -            | 0     |
- Noise


Update x86_64-linux host compiler to LLVM 19 rc 3 [#129356](https://github.com/rust-lang/rust/pull/129356) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=d6c8169c186ab16a3404cd0d0866674018e8a19e&end=842d6fc32e3d0d26bb11fbe6a2f6ae2afccc06cb&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.5%  | [0.2%, 0.8%]   | 34    |
| Regressions ❌ <br /> (secondary)  | 2.6%  | [0.5%, 5.7%]   | 6     |
| Improvements ✅ <br /> (primary)   | -0.4% | [-0.4%, -0.4%] | 1     |
| Improvements ✅ <br /> (secondary) | -     | -              | 0     |
| All ❌✅ (primary)                 | 0.5%  | [-0.4%, 0.8%]  | 35    |
- "Looks like this update is a very mild regression, but not enough to look into it in more detail, or skip this version."


Rollup of 10 pull requests [#130091](https://github.com/rust-lang/rust/pull/130091) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=12b26c13fba25c9e1bc2fdf05f3c2dbb851c83de&end=878f49f5ff0dd88a85bcd5d99fc0d90e219c354c&stat=instructions:u)

| (instructions:u)                   | mean | range        | count |
|:----------------------------------:|:----:|:------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.9% | [0.3%, 1.7%] | 13    |
| Regressions ❌ <br /> (secondary)  | 0.8% | [0.2%, 1.3%] | 14    |
| Improvements ✅ <br /> (primary)   | -    | -            | 0     |
| Improvements ✅ <br /> (secondary) | -    | -            | 0     |
| All ❌✅ (primary)                 | 0.9% | [0.3%, 1.7%] | 13    |
- Regressions are happening in `expand_crate` so testing a change that touched `rustc_expand`


#### Improvements

Use `DeepRejectCtxt` to quickly reject `ParamEnv` candidates [#128776](https://github.com/rust-lang/rust/pull/128776) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=17b322fa69eed7216dccc9f097eb68237cf62234&end=26b5599e4d6ed2b45152c60493c1788c0a27533d&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -1.8% | [-4.7%, -0.3%] | 17    |
| Improvements ✅ <br /> (secondary) | -     | -              | 0     |
| All ❌✅ (primary)                 | -1.8% | [-4.7%, -0.3%] | 17    |


#### Mixed

Rollup of 10 pull requests [#129978](https://github.com/rust-lang/rust/pull/129978) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=009e73825af0e59ad4fc603562e038b3dbd6593a&end=eb33b43bab08223fa6b46abacc1e95e859fe375d&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.4%  | [0.3%, 0.5%]   | 4     |
| Regressions ❌ <br /> (secondary)  | 0.4%  | [0.4%, 0.4%]   | 1     |
| Improvements ✅ <br /> (primary)   | -     | -              | 0     |
| Improvements ✅ <br /> (secondary) | -3.1% | [-3.1%, -3.1%] | 1     |
| All ❌✅ (primary)                 | 0.4%  | [0.3%, 0.5%]   | 4     |
- The regressions here are small enough that I don't think it's worth investigating further.


stabilize `-Znext-solver=coherence` [#121848](https://github.com/rust-lang/rust/pull/121848) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=59d4114b2d1aaac9a6dfe770997f2e79ccfd28ab&end=17b322fa69eed7216dccc9f097eb68237cf62234&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.4%  | [0.2%, 0.6%]   | 11    |
| Regressions ❌ <br /> (secondary)  | 1.1%  | [0.4%, 5.1%]   | 8     |
| Improvements ✅ <br /> (primary)   | -3.4% | [-4.2%, -2.8%] | 7     |
| Improvements ✅ <br /> (secondary) | -0.3% | [-0.3%, -0.2%] | 5     |
| All ❌✅ (primary)                 | -1.1% | [-4.2%, 0.6%]  | 18    |
- Mainly noise

