# 2024-10-14 Triage Log

No major changes this week.

Triage done by **@simulacrum**.
Revision range: [e6c46db4..5ceb623a](https://perf.rust-lang.org/?start=e6c46db4e9fd11e3183c397a59d946731034ede6&end=5ceb623a4abd66e91e7959d25caaf0523f1a7f7c&absolute=false&stat=instructions%3Au)

**Summary**:

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.2%  | [0.2%, 0.2%]   | 1     |
| Regressions ❌ <br /> (secondary)  | 0.5%  | [0.2%, 2.9%]   | 16    |
| Improvements ✅ <br /> (primary)   | -0.3% | [-0.4%, -0.2%] | 14    |
| Improvements ✅ <br /> (secondary) | -0.6% | [-1.7%, -0.1%] | 32    |
| All ❌✅ (primary)                 | -0.2% | [-0.4%, 0.2%]  | 15    |


1 Regression, 1 Improvement, 2 Mixed; 2 of them in rollups
36 artifact comparisons made in total

#### Regressions

Introduce SolverRelating type relation to the new solver [#131263](https://github.com/rust-lang/rust/pull/131263) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=4cc494bbfe9911d24f3ee521f98d5c6bb7e3ffe8&end=8d94e06ec9758b5c03ea77bb5dab22a1a76bc261&stat=instructions:u)

| (instructions:u)                   | mean | range        | count |
|:----------------------------------:|:----:|:------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.2% | [0.2%, 0.2%] | 1     |
| Regressions ❌ <br /> (secondary)  | 0.5% | [0.2%, 2.7%] | 9     |
| Improvements ✅ <br /> (primary)   | -    | -            | 0     |
| Improvements ✅ <br /> (secondary) | -    | -            | 0     |
| All ❌✅ (primary)                 | 0.2% | [0.2%, 0.2%] | 1     |

Genuine, if small, regressions on a number of benchmarks. Likely required as
part of the broader move to the new solver.

#### Improvements

Rollup of 8 pull requests [#131628](https://github.com/rust-lang/rust/pull/131628) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=6b9676b45431a1e531b9c5f7bd289fc36a312749&end=ef4e8259b5016d85e261587b605028b2ff06c13d&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | 0.5%  | [0.3%, 0.6%]   | 2     |
| Improvements ✅ <br /> (primary)   | -0.3% | [-0.3%, -0.2%] | 8     |
| Improvements ✅ <br /> (secondary) | -0.6% | [-1.8%, -0.1%] | 31    |
| All ❌✅ (primary)                 | -0.3% | [-0.3%, -0.2%] | 8     |

Seems most likely to be due to "Shallowly match opaque key in storage
[#131599](https://github.com/rust-lang/rust/pull/131599)" but not confirming
since this is an improvement.

#### Mixed

Rollup of 7 pull requests [#131581](https://github.com/rust-lang/rust/pull/131581) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=fb20e4d3b96d1de459d086980a8b99d5060ad9fe&end=8f8bee4f60d9d3769f75c70d558c27a95761c554&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | -     | -              | 0     |
| Regressions ❌ <br /> (secondary)  | 0.4%  | [0.3%, 0.6%]   | 6     |
| Improvements ✅ <br /> (primary)   | -0.3% | [-1.0%, -0.2%] | 7     |
| Improvements ✅ <br /> (secondary) | -2.5% | [-2.5%, -2.5%] | 1     |
| All ❌✅ (primary)                 | -0.3% | [-1.0%, -0.2%] | 7     |

Possibly spurious (and/or bi-modality) regression confined to tt-muncher
(though across multiple scenarios). No need for further investigation,
particular given a rollup.

Add `#[track_caller]` to allocating methods of `Vec` & `VecDeque` [#126557](https://github.com/rust-lang/rust/pull/126557) [(Comparison Link)](https://perf.rust-lang.org/compare.html?start=5ceb623a4abd66e91e7959d25caaf0523f1a7f7c&end=f6648f252a05a0a46c865d7ec836b46290613bf9&stat=instructions:u)

| (instructions:u)                   | mean  | range          | count |
|:----------------------------------:|:-----:|:--------------:|:-----:|
| Regressions ❌ <br /> (primary)    | 0.3%  | [0.0%, 0.5%]   | 26    |
| Regressions ❌ <br /> (secondary)  | -     | -              | 0     |
| Improvements ✅ <br /> (primary)   | -     | -              | 0     |
| Improvements ✅ <br /> (secondary) | -0.2% | [-0.2%, -0.1%] | 4     |
| All ❌✅ (primary)                 | 0.3%  | [0.0%, 0.5%]   | 26    |

Seems to be accepted by T-libs
(https://github.com/rust-lang/rust/pull/126557#issuecomment-2329482185).
An expected regression pre-merge.
